delegate.create("gardenbot")
--------------------------------------------------------------------------------
gardenbot = {}
profilerApi = {}
--------------------------------------------------------------------------------
function isGardenbot() return true end
--------------------------------------------------------------------------------
function isPleasedGiraffe() 
if self.isPleasedGiraffe == nil then 
if world.spawnTreasure and world.objectSpaces then self.isPleasedGiraffe = true 
else self.isPleasedGiraffe = false end end

return self.isPleasedGiraffe
end
--------------------------------------------------------------------------------
function isGladGiraffe() 
end
--------------------------------------------------------------------------------
function gardenbot.init(args)
  entity.setDeathParticleBurst("deathPoof")
  setAnimationState("movement", "idle")
  entity.setAggressive(entity.configParameter("aggressive"),false)
  
  self.inv = inventoryManager.create()

  self.ignore = {beakseed = true, talonseed = true, seedpile = true}
  self.ignoreIds = {}
  storage.seedMemory = {}
  storage.failedMemory = {}
  if storage.uuid == nil then storage.uuid = entity.configParameter("selfUuid",sb.makeUuid()) end
  if storage.efficiency == nil then storage.efficiency = 0.75 end
  local harvest = entity.configParameter("gardenSettings.gatherables")
  if harvest ~= nil then
    self.harvest = {}
    self.harvestMatch = {}
    self.harvestType = {}
    for _,v in ipairs(harvest) do
      if type(v) == "string" then self.harvest[string.lower(v)] = true end
      if type(v) == "table" then
        for h,t in pairs(v) do
          if t == "match" then table.insert(self.harvestMatch, h) end
          if t == "type" then self.harvestType[string.lower(h)] = true end
        end
      end
    end
  end
  self.searchType = entity.configParameter("gardenSettings.searchType")
  self.searchDistance = entity.configParameter("gardenSettings.searchDistance")
  
  self.spawnPoint = entity.configParameter("spawnPoint") or mcontroller.position()
  self.lastMoveDirection = util.randomDirection()
  self.shielded = false
  
  script.setUpdateDelta(10)
  self.isCodeProfiling = type(profilerApi.init) == "function" and false
  if self.isCodeProfiling then profilerApi.init() end
  storage.blockstats = nil
end
--------------------------------------------------------------------------------
function gardenbot.damage(args)
--world.logInfo("\ndamage args: %s",args)
  if args.sourceId >= 0 or world.isNpc(args.sourceId) or world.isMonster(args.sourceId) then -- not a player, hax hp
    status.setResource("health", status.stat("maxHealth"))
  end

  if entity.health() <= 0 and not self.dead then -- lpk: also check dead to fix dupe exploit ;(
--  debugfunctables()
--  printTable(0,_ENV)
  if storage.blockstats ~= nil then world.logInfo("\nBlockStats: %s",storage.blockstats) end
  if self.isCodeProfiling then profilerApi.logData() end
    local spawner = nil
    if entity.type() then spawner = entity.type() .. "spawner" end
    if spawner ~= nil then self.inv.add({name = spawner, count = 1}) end
    self.inv.drop({all = true, position = mcontroller.position()})
    self.dead = true
    if entity.hasSound("dead") then entity.playSound("dead") end
  else
  self.state.pickState(args.sourceId) -- not dead, attack back
  end
end
--------------------------------------------------------------------------------
function debugfunctables()
if not self.debug then return end
util.debugLog("\nroot: \n%s",root)
util.debugLog("\nsb: \n%s",sb)
--util.debugLog("\nuniverse: \n%s",universe)
util.debugLog("\nworld: \n%s",world)
util.debugLog("\nentity: \n%s",entity)
util.debugLog("\nmcontroller: \n%s",mcontroller)
util.debugLog("\nstatus: \n%s",status)

end
--------------------------------------------------------------------------------
function shouldDie()
  return self.dead
end
--------------------------------------------------------------------------------
function cooldown(base)
if base == nil then base = entity.configParameter("gardenSettings.cooldown", 15) end
if type(base) ~= "number" then return 1 end
return (base + math.random(base))/2
end

--------------------------------------------------------------------------------
function canReachTarget(target, ignoreLOS)
  local position = nil
  local pad = 1.2
  if type(target) == "number" then
    position = world.entityPosition(target)
    pad = pad + entity.configParameter("gardenSettings.interactRange") / 2
  elseif type(target) == "table" then
    position = target
  end
  if position == nil then return nil end
  local collision = false
  local ep = mcontroller.position()

  local ctype
  if isPleasedGiraffe() then    ctype = {"Null","Block","Dynamic"}
  else   ctype = "Any"  end
  local blocks = world.collisionBlocksAlongLine(ep, position, ctype, 2)
  collision = blocks[1] ~= nil
  if string.find(self.searchType, 'lumber$') then collision = #blocks == 2 end --lpk: why?
  local fovHeight = entity.configParameter("gardenSettings.fovHeight",2)/2
  local min = nil
  local max = nil
  ep[2] = ep[2] + mcontroller.boundBox()[2] + fovHeight-- lpk: fix for lumber foot pos
  --Target to the left
  if ep[1] > position[1] then
    min = {position[1]+pad, ep[2] - fovHeight}
    max = {ep[1]-pad, ep[2] + fovHeight}
  --Target to the right
  else
    min = {ep[1]+pad, ep[2] - fovHeight}
    max = {position[1]-pad, ep[2] + fovHeight}
  end
--util.debugRect({min[1],min[2],max[1],max[2]},"#ff00ff")
  local oIds = world.objectQuery(min, max, { callScript = "entity.configParameter", callScriptArgs = {"category"}, callScriptResult = "gardenfence" })
  if oIds[1] ~= nil then
     return false,world.entityPosition(oIds[1])
  end
  return ignoreLOS == true or not collision
end
--------------------------------------------------------------------------------
function distanceSort(a, b)
  local position = mcontroller.position()
  local da = world.magnitude(position, world.entityPosition(a))
  local db = world.magnitude(position, world.entityPosition(b))
  return da < db
end
--------------------------------------------------------------------------------
function isOre(modName)
oreList = {
"aegisalt","coal","copper","corefragment","crystal","diamond","fossil","gold","iron",
"lead","moonstone","platinum","plutonium","prisilite","rubium","silverore","solarium",
"sulphur","titanium","trianglium","uranium","violium"
}
  for i,v in ipairs(oreList) do
    if v == modName then return true end
  end
  return false
end

function dropNameFromMod(modName)
oreMap = {
"aegisaltore","coalore","copperore","corefragmentore","crystal","diamond","fossilore","goldore","ironore", 
"lead","moonstoneore","platinumore","plutoniumore","prisiliteore","rubiumore","silverore","solariumore",
"sulphur","titaniumore","triangliumore","uraniumore","violiumore"
}
  for i,v in ipairs(oreMap) do
    if string.find(v,modName) then return v end
  end
  return "perfectlygenericitem" -- should never get here, but if it happens...
end

--------------------------------------------------------------------------------
function touchingFenceDirection(mcPos,moveDir)
  --lpk: called by move, check for fence here, returns a direction
  -- for some reason profiling makes this not work?!wtfh
  local outDir = util.toDirection(moveDir)   
  local b,t = canReachTarget(vec2.add(mcPos, {outDir*1.5, 0}))
  if not b and t ~= nil then -- hit garden fence
    local distance = world.distance(t, mcPos)
    outDir = -util.toDirection(distance[1]) -- bounce
	  local passDir = util.toDirection(distance[1]) -- passthru to homebin maybe?
    local binPos = entity.configParameter("spawnPoint")-- use spawn if no homebin
	  if self.homeBin ~= nil and world.entityExists(self.homeBin) then
	    binPos = world.entityPosition(self.homeBin)
	  end
	  local binDist = world.distance(binPos, mcPos)
	  local binDir = util.toDirection(binDist[1])
	  if binDir == passDir then 
		  outDir = passDir 
	  end  
--	if mcontroller.onGround() then
--    mcontroller.setVelocity({moveDir * world.gravity(mcontroller.position()),0})
--  end
  if self.debug then
    world.debugText("%s",outDir,vec2.add(t,{-0.5,3}),"yellow")
    util.debugRect({t[1],t[2],t[1]+1,t[2]+3},"yellow")
  end
  end
 return outDir * math.abs(moveDir)
end
--------------------------------------------------------------------------------

function maybeKickPetball() -- kick ball instead of damaging it, not that bot did dmg anyway >.>
  if self.targetId and world.entityExists(self.targetId) 
  and world.monsterType(self.targetId) == "petball" then
    world.callScriptedEntity(self.targetId, "punt", mcontroller.facingDirection())
    return true
  end
  return false
end
--------------------------------------------------------------------------------
function chatNearbyPlayerOrBot()
-- report current inventory to players ?
-- binary art for bots - icons built into hobo etc.
  --  entity.say("01000101") "ð«""ԑ(þ)Ӟ"

  -- entity.say doesnt work, may have to spawn a temp item like gardenplot that only does say then breaks
end

--------------------------------------------------------------------------------
-- movement funcs, mostly cribbed from groundmovement.lua
--------------------------------------------------------------------------------
-- NOTE: this will be inaccurate if called more than once per tick
function checkStuck()
  local newPos = mcontroller.position()
  if newPos[1] == self.stuckPosition[1] and newPos[2] == self.stuckPosition[2] then
    self.stuckCount = self.stuckCount + 1
  else
    self.stuckCount = 0
    self.stuckPosition = newPos
  end

  return self.stuckCount
end

--------------------------------------------------------------------------------
function calculateSeparationMovement()
  local entityIds = world.entityQuery(mcontroller.position(), 0.5, { includedTypes = {"monster"}, withoutEntityId = entity.id(), order = "nearest" })
  if #entityIds > 0 then
    local separationMovement = world.distance(mcontroller.position(), world.entityPosition(entityIds[1]))
    return util.toDirection(separationMovement[1])
  end

  return 0
end

--------------------------------------------------------------------------------
function travelTime(distance) -- lpk: modded to accept a pos also
  if type(distance) == "table" then return travelTimeToPos(distance) end
  local runSpeed = mcontroller.baseParameters().walkSpeed
  return math.abs(distance / runSpeed)
end

function travelTimeToPos(pos)
  local toTarget = world.distance(pos, mcontroller.position())
  local distance = world.magnitude(toTarget)
  local runSpeed = mcontroller.baseParameters().walkSpeed
  return math.abs(distance / runSpeed)
end
--------------------------------------------------------------------------------
-- estimate the maximum jump duration
function jumpTime()
  return (2 * mcontroller.baseParameters().airJumpProfile.jumpSpeed) / (world.gravity(mcontroller.position()) * 1.5)
end

--------------------------------------------------------------------------------
-- estimate the maximum jump height
function jumpHeight()
  return (mcontroller.baseParameters().airJumpProfile.jumpSpeed * jumpTime()) / 4
end

--------------------------------------------------------------------------------
function faceTarget()
  if self.onGround then
    mcontroller.controlFace(self.toTarget[1])
  end
end

--------------------------------------------------------------------------------
function controlFace(direction)
  if self.onGround then
    mcontroller.controlFace(direction)
  end
end

--------------------------------------------------------------------------------
function isBlocked(direction)
  local direction = direction or mcontroller.facingDirection()
  local position = mcontroller.position()
  position[1] = position[1] + direction

  if not world.resolvePolyCollision(mcontroller.collisionPoly(), position, 0.8) then
    return true
  end
  return false
end

--------------------------------------------------------------------------------
function willFall(direction)
  local direction = direction or mcontroller.facingDirection()
  local position = mcontroller.position()
  position[1] = position[1] + direction
  --Snap the position forward
  position[1] = direction > 0 and math.ceil(position[1]) or math.floor(position[1])

  local bounds = mcontroller.boundBox()

  local groundRegion = {
    math.floor(position[1] + bounds[1]), math.ceil(position[2] + bounds[2] - 1),
    math.ceil(position[1] + bounds[3]), math.ceil(position[2] + bounds[2])
  }
  if isPleasedGiraffe() then 
  if world.rectTileCollision(groundRegion, {"Null","Block","Dynamic","Platform"}) then return false end
  else
  if world.rectTileCollision(groundRegion, "Any") then return false end
  end
  return true
end
--------------------------------------------------------------------------------
-- lpk: generic~ish animation setter - some v87g specifics so shield animates correctly
function setAnimationState(base, state)
local anim = entity.animationState(base)
  if anim == state or (anim == "shieldStart" and state ~= "shieldEnd") or (anim == "shieldEnd" and state ~= "shieldStart") then return end
  if self.shielded and state == "shieldStart" then return end
  if self.shielded and state ~= "shieldEnd" then return end
  entity.setAnimationState(base,state)
end
--------------------------------------------------------------------------------
-- nearby monster was hurt, lets help kill it :D
function monsterDamaged(entityId, entitySeed, damageSourceId)
  if self.targetId == nil and damageSourceId > 0 and damageSourceId ~= entity.id()
  and world.callScriptedEntity(damageSourceId,"isGardenbot") == true then
-- no targ, damID not player, damID not self, damID is gbot
    self.state.pickState(entityId)
  end
end
--------------------------------------------------------------------------------

function itemCategory(item) -- lpk
--   world.logInfo("\n%s\n%s",item,root.itemConfig(item.name).config.category)
 if item.parameters and item.parameters.itemName then
    if item.parameters.itemName == "generatedgun" then return item.parameters.weaponType end
    if item.parameters.generated then return nil end
    return root.itemConfig(item.parameters.itemName).config.category
  end
  return root.itemConfig(item.name).config.category
end
      
--------------------------------------------------------------------------------
-- lpk: copy entityproxy, as its small
entityProxy = {}

function entityProxy.create(entityId)
  local wrappers = {}

  local proxyMetatable = {
    __index = function(t, functionName)
      local wrapper = wrappers[functionName]
      if wrapper == nil then
        wrapper = function(...)
          return world.callScriptedEntity(entityId, "entity." .. functionName, ...)
        end
        wrappers[functionName] = wrapper
      end

      return wrapper
    end,

    __newindex = function(t, key, val) end
  }

  local proxy = {}
  setmetatable(proxy, proxyMetatable)
  return proxy
end

--------------------------------------------------------------------------------

--prints tables
function printTable(indent, value)
    local tabs = "";
    for i=1,indent,1 do
        tabs = tabs.."    ";
    end
    table.sort(value)
    for k,v in pairs(value) do
        world.logInfo(tabs..getValueOutput(k,v));
        if type(v) == "table" then
            if tostring(k) == "utf8" then
                world.logInfo("    "..tabs.."SKIPPING UTF8")-- SINCE IT SEEMS TO HAVE NO END AND JUST BE FILLED WITH TABLES OF TABLES
            else
                if tableLen(v) == 0 then
                    world.logInfo("    "..tabs.."EMPTY TABLE")
                else
                    printTable(indent+1,v);
                 
                end
            end
            world.logInfo(" ");
        end
    end
 
end

function tableLen(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end

--Required for printTable
function getValueOutput(key ,value)
    if type(value) == "table" then
        return "table : "..key;
    elseif type(value) == "function" then
        return "function : "..key.."()"
    elseif type(value) == "string" then
        return "string : "..key.." - \""..tostring(value).."\"";
    else
        return type(value).." : "..key.." - "..tostring(value);
    end
end